/* InputBox Function for password */
#include "unzip.h"
#include "crypt.h"

#ifdef CRYPT /* If no crypt don't use */

#include "windows.h"
#include "globals.h"
#include "resource.h"

CHAR lpszPassword[PWLEN+1]; // PWLEN=80
WORD cchPassword;
BOOL pwork;
INT  rcode;

//IDC_PROMPT

BOOL CALLBACK PassProc(hDlg, message, wParam, lParam)
HWND hDlg;                /* window handle of the dialog box */
UINT message;             /* type of message                 */
UINT wParam;              /* message-specific information    */
LONG lParam;
{
    switch (message) {
        case WM_INITDIALOG:

            /* Set password character to an asterisk (*) */
            SendDlgItemMessage(hDlg,
                IDE_PASSWORDEDIT,
                EM_SETPASSWORDCHAR,
                (WPARAM) '*',
                (LPARAM) 0);


            /* Set the default push button to "Cancel." */
            SendMessage(hDlg,
                DM_SETDEFID,
                (WPARAM) IDCANCEL,
                (LPARAM) 0);

            pwork = TRUE;
            rcode = 0;
            return TRUE;

        case WM_COMMAND:
            /*
             * Set the default push button to "OK" when the user
             * enters text.
             */
           if (HIWORD (wParam) == EN_CHANGE &&
               LOWORD(wParam) == IDE_PASSWORDEDIT)
                 SendMessage(hDlg,
                    DM_SETDEFID,
                    (WPARAM) IDOK,
                    (LPARAM) 0);

            switch(wParam) {
                case IDOK:
                    /* Get number of characters. */
                    cchPassword = (WORD) SendDlgItemMessage(hDlg,
                        IDE_PASSWORDEDIT,
                        EM_LINELENGTH,
                        (WPARAM) 0,
                        (LPARAM) 0);

                    if (cchPassword >= PWLEN+1) {
                        MessageBox(hDlg,
                            "Too many characters.",
                            "Error",
                            MB_OK);
                        EndDialog(hDlg, TRUE);
                        rcode = IZ_PW_ERROR;
                        return FALSE;
                    }

                    else if (cchPassword == 0) {
                        MessageBox(hDlg,
                            "No characters entered.",
                            "Error",
                            MB_OK);
                        EndDialog(hDlg, TRUE);
                        rcode = IZ_PW_CANCELALL;
                        return FALSE;
                    }

                    /*
                     * Put the number of characters into first word
                     * of buffer.
                     */
                    *((LPWORD)lpszPassword) = cchPassword;

                    /* Get the characters. */
                    SendDlgItemMessage(hDlg,
                        IDE_PASSWORDEDIT,
                        EM_GETLINE,
                        (WPARAM) 0,       /* line 0 */
                        (LPARAM) lpszPassword);

                    /* Null-terminate the string. */
                    lpszPassword[cchPassword] = 0;

                    /* Call a local password-parsing function. */
                    rcode = IZ_PW_ENTERED;
                    EndDialog(hDlg, TRUE);
                    return TRUE;

                case IDCANCEL:
                    rcode = IZ_PW_CANCELALL;
                    EndDialog(hDlg, TRUE);
                    return TRUE;
            }
            return 0;

    }
    return FALSE;
    UNREFERENCED_PARAMETER(lParam);
}


/* Zip uses this call */
/* getp("Enter password: ", key, PWLEN + 1) == NULL) { */

/* Unzip uses this call */
// r = (*G.decr_passwd)((zvoid *)&G, &n, GLOBAL(key), PWLEN+1,
//                       GLOBAL(zipfn), GLOBAL(filename));

int UzpGetPassWrd(pG, rcnt, pkey, size, zfn, efn)
zvoid *pG;
int *rcnt;
char *pkey;
int size;
char *zfn;
char *efn;
{
   HINSTANCE hnd;

   pwork = FALSE;

   hnd = GetModuleHandle("unzdll.dll");
   if (hnd != 0) {

      if (DialogBox(hnd, MAKEINTRESOURCE(IDD_DIALOG1),
         (HWND)global_handle, (DLGPROC) PassProc) == FALSE)
            MessageBox((HWND)global_handle, "DialogBox failed", 
                                   "Procedure Failure", MB_OK);

      if (!pwork)
          return IZ_PW_ERROR;

      if ((memcpy(pkey, lpszPassword, cchPassword)) == NULL) 
          return IZ_PW_ERROR;
          pkey[cchPassword] = '\0';
          return rcode;
   }
   return 0;
}

#endif /* crypt */
